require(ape)
require(MCMCglmm)

#Read phylo tree & working dataset
phylo<-read.tree("~/Dropbox/FeederWatch_Interaction_Strength_MS/Datasets/feederwatch_phylo.tree")
## Read phylo from Gavin's machine ##
# phylo<-read.tree("/Users/gavinleighton/Dropbox/FeederWatch_Interaction_Strength_MS/Datasets/feederwatch_phylo.tree")

load('~/Dropbox/FeederWatch_Interaction_Strength_MS/Datasets/INphylo_FW.RData')
## Read data from Gavin's machine
# load('/Users/gavinleighton/Dropbox/FeederWatch_Interaction_Strength_MS/Datasets/INphylo_FW.RData')
pairdata<-read.csv("~/Dropbox/FeederWatch_Interaction_Strength_MS/Datasets/species_pair_data.csv",header=TRUE)
## Read data from Gavin's machine
# pairdata<-read.csv("/Users/gavinleighton/Dropbox/FeederWatch_Interaction_Strength_MS/Datasets/species_pair_data.csv",header=TRUE)
pairdata$sympatry.sq<-pairdata$ebird.min.sympatry^2
pairdata$ln.syntopy<-log(pairdata$ebird.overall.syntopy+0.01)
pairdata$ln.syntopy.quad<- (pairdata$ln.syntopy)^2


#fits without territoriality

pairdata.obs1<-subset(pairdata,observed1==1)

prior<-list(G=list(G1=list(V=1,nu=0.002),G2=list(V=1,nu=0.002),G3=list(V=1,nu=0.002)),R=list(V=1,nu=0.02))


model_dir_chain1<-MCMCglmm(directionality~scale(sqrt.diff.body.mass)*scale(patristic.distance)+both.sedentary+pairdiet+pairforaging+scale(sympatry.sq)+scale(ln.syntopy)+scale(highest.intraspecific.ses),random=~animal+sp1.sorted+sp2.sorted,
                family="gaussian",ginverse=list(animal=INphylo_FW$Ainv),prior=prior,
                data=pairdata.obs1,nitt=500000,burnin=1000,thin=500)
save(model_dir_chain1,file="model_dir_chain1.RData")

model_dir_chain2<-MCMCglmm(directionality~scale(sqrt.diff.body.mass)*scale(patristic.distance)+both.sedentary+pairdiet+pairforaging+scale(sympatry.sq)+scale(ln.syntopy)+scale(highest.intraspecific.ses),random=~animal+sp1.sorted+sp2.sorted,
                family="gaussian",ginverse=list(animal=INphylo_FW$Ainv),prior=prior,
                data=pairdata.obs1,nitt=500000,burnin=1000,thin=500)
save(model_dir_chain2,file="model_dir_chain2.RData")

model_dir_chain3<-MCMCglmm(directionality~scale(sqrt.diff.body.mass)*scale(patristic.distance)+both.sedentary+pairdiet+pairforaging+scale(sympatry.sq)+scale(ln.syntopy)+scale(highest.intraspecific.ses),random=~animal+sp1.sorted+sp2.sorted,
                family="gaussian",ginverse=list(animal=INphylo_FW$Ainv),prior=prior,
                data=pairdata.obs1,nitt=500000,burnin=1000,thin=500)
save(model_dir_chain3,file="model_dir_chain3.RData")

model_dir_chain4<-MCMCglmm(directionality~scale(sqrt.diff.body.mass)*scale(patristic.distance)+both.sedentary+pairdiet+pairforaging+scale(sympatry.sq)+scale(ln.syntopy)+scale(highest.intraspecific.ses),random=~animal+sp1.sorted+sp2.sorted,
                family="gaussian",ginverse=list(animal=INphylo_FW$Ainv),prior=prior,
                data=pairdata.obs1,nitt=500000,burnin=1000,thin=500)
save(model_dir_chain4,file="model_dir_chain4.RData")

#fits without territoriality and with quadratic term
# setwd("/Users/gavinleighton/Dropbox/FeederWatch_Interaction_Strength_MS/Analyses/Directionality")
pairdata.obs1<-subset(pairdata,observed1==1)

prior<-list(G=list(G1=list(V=1,nu=0.002),G2=list(V=1,nu=0.002),G3=list(V=1,nu=0.002)),R=list(V=1,nu=0.02))


model_dir_chain1<-MCMCglmm(directionality~scale(sqrt.diff.body.mass)*scale(patristic.distance)+both.sedentary+pairdiet+pairforaging+scale(sympatry.sq)+scale(ln.syntopy)+scale(ln.syntopy.quad) +scale(highest.intraspecific.ses),random=~animal+sp1.sorted+sp2.sorted,
                           family="gaussian",ginverse=list(animal=INphylo_FW$Ainv),prior=prior,
                           data=pairdata.obs1,nitt=500000,burnin=1000,thin=500)
save(model_dir_chain1,file="model_dir_quad_chain1.RData")

model_dir_chain2<-MCMCglmm(directionality~scale(sqrt.diff.body.mass)*scale(patristic.distance)+both.sedentary+pairdiet+pairforaging+scale(sympatry.sq)+scale(ln.syntopy)++scale(ln.syntopy.quad)+scale(highest.intraspecific.ses),random=~animal+sp1.sorted+sp2.sorted,
                           family="gaussian",ginverse=list(animal=INphylo_FW$Ainv),prior=prior,
                           data=pairdata.obs1,nitt=500000,burnin=1000,thin=500)
save(model_dir_chain2,file="model_dir_quad_chain2.RData")

model_dir_chain3<-MCMCglmm(directionality~scale(sqrt.diff.body.mass)*scale(patristic.distance)+both.sedentary+pairdiet+pairforaging+scale(sympatry.sq)+scale(ln.syntopy)+scale(highest.intraspecific.ses),random=~animal+sp1.sorted+sp2.sorted,
                           family="gaussian",ginverse=list(animal=INphylo_FW$Ainv),prior=prior,
                           data=pairdata.obs1,nitt=500000,burnin=1000,thin=500)
save(model_dir_chain3,file="model_dir_quad_chain3.RData")

model_dir_chain4<-MCMCglmm(directionality~scale(sqrt.diff.body.mass)*scale(patristic.distance)+both.sedentary+pairdiet+pairforaging+scale(sympatry.sq)+scale(ln.syntopy)+scale(highest.intraspecific.ses),random=~animal+sp1.sorted+sp2.sorted,
                           family="gaussian",ginverse=list(animal=INphylo_FW$Ainv),prior=prior,
                           data=pairdata.obs1,nitt=500000,burnin=1000,thin=500)
save(model_dir_chain4,file="model_dir_quad_chain4.RData")


## fits without quad term for DIC comp ##

model_dir_chain1_comp <-MCMCglmm(directionality~scale(sqrt.diff.body.mass)*scale(patristic.distance)+both.sedentary+pairdiet+pairforaging+scale(sympatry.sq)+scale(ln.syntopy) +scale(highest.intraspecific.ses),random=~animal+sp1.sorted+sp2.sorted,
                           family="gaussian",ginverse=list(animal=INphylo_FW$Ainv),prior=prior,
                           data=pairdata.obs1,nitt=500000,burnin=1000,thin=500)


#fits with territoriality

pairdata.obs1_terr<-subset(pairdata,observed1==1 & !is.na(both.terr.4.5.max))


prior<-list(G=list(G1=list(V=1,nu=0.002),G2=list(V=1,nu=0.002),G3=list(V=1,nu=0.002)),R=list(V=1,nu=0.02))


model_dir_terr_chain1<-MCMCglmm(directionality~scale(sqrt.diff.body.mass)*scale(patristic.distance)+both.terr.4.5.max+both.sedentary+pairdiet+pairforaging+scale(sympatry.sq)+scale(ln.syntopy)+scale(highest.intraspecific.ses),random=~animal+sp1.sorted+sp2.sorted,
                family="gaussian",ginverse=list(animal=INphylo_FW$Ainv),prior=prior,
                data=pairdata.obs1_terr,nitt=500000,burnin=1000,thin=500)
save(model_dir_terr_chain1,file="model_dir_terr_chain1.RData")

model_dir_terr_chain2<-MCMCglmm(directionality~scale(sqrt.diff.body.mass)*scale(patristic.distance)+both.terr.4.5.max+both.sedentary+pairdiet+pairforaging+scale(sympatry.sq)+scale(ln.syntopy)+scale(highest.intraspecific.ses),random=~animal+sp1.sorted+sp2.sorted,
                family="gaussian",ginverse=list(animal=INphylo_FW$Ainv),prior=prior,
                data=pairdata.obs1_terr,nitt=500000,burnin=1000,thin=500)
save(model_dir_terr_chain2,file="model_dir_terr_chain2.RData")

model_dir_terr_chain3<-MCMCglmm(directionality~scale(sqrt.diff.body.mass)*scale(patristic.distance)+both.terr.4.5.max+both.sedentary+pairdiet+pairforaging+scale(sympatry.sq)+scale(ln.syntopy)+scale(highest.intraspecific.ses),random=~animal+sp1.sorted+sp2.sorted,
                family="gaussian",ginverse=list(animal=INphylo_FW$Ainv),prior=prior,
                data=pairdata.obs1_terr,nitt=500000,burnin=1000,thin=500)
save(model_dir_terr_chain3,file="model_dir_terr_chain3.RData")

model_dir_terr_chain4<-MCMCglmm(directionality~scale(sqrt.diff.body.mass)*scale(patristic.distance)+both.terr.4.5.max+both.sedentary+pairdiet+pairforaging+scale(sympatry.sq)+scale(ln.syntopy)+scale(highest.intraspecific.ses),random=~animal+sp1.sorted+sp2.sorted,
                family="gaussian",ginverse=list(animal=INphylo_FW$Ainv),prior=prior,
                data=pairdata.obs1_terr,nitt=500000,burnin=1000,thin=500)
save(model_dir_terr_chain4,file="model_dir_terr_chain4.RData")


#fits without syntopy outlier (case where green jay and tufted titmouse never co-occur on ebird list)

pairdata.obs1_subset<-subset(pairdata,observed1==1 & !is.na(ses.vec))

prior<-list(G=list(G1=list(V=1,nu=0.002),G2=list(V=1,nu=0.002),G3=list(V=1,nu=0.002)),R=list(V=1,nu=0.02))


model_subset_dir_chain1<-MCMCglmm(directionality~scale(sqrt.diff.body.mass)*scale(patristic.distance)+both.sedentary+pairdiet+pairforaging+scale(sympatry.sq)+scale(ln.syntopy)+scale(highest.intraspecific.ses),random=~animal+sp1.sorted+sp2.sorted,
                family="gaussian",ginverse=list(animal=INphylo_FW$Ainv),prior=prior,
                data=pairdata.obs1_subset,nitt=500000,burnin=1000,thin=500)
save(model_subset_dir_chain1,file="model_subset_dir_chain1.RData")

model_subset_dir_chain2<-MCMCglmm(directionality~scale(sqrt.diff.body.mass)*scale(patristic.distance)+both.sedentary+pairdiet+pairforaging+scale(sympatry.sq)+scale(ln.syntopy)+scale(highest.intraspecific.ses),random=~animal+sp1.sorted+sp2.sorted,
                family="gaussian",ginverse=list(animal=INphylo_FW$Ainv),prior=prior,
                data=pairdata.obs1_subset,nitt=500000,burnin=1000,thin=500)
save(model_subset_dir_chain2,file="model_subset_dir_chain2.RData")

model_subset_dir_chain3<-MCMCglmm(directionality~scale(sqrt.diff.body.mass)*scale(patristic.distance)+both.sedentary+pairdiet+pairforaging+scale(sympatry.sq)+scale(ln.syntopy)+scale(highest.intraspecific.ses),random=~animal+sp1.sorted+sp2.sorted,
                family="gaussian",ginverse=list(animal=INphylo_FW$Ainv),prior=prior,
                data=pairdata.obs1_subset,nitt=500000,burnin=1000,thin=500)
save(model_subset_dir_chain3,file="model_subset_dir_chain3.RData")

model_subset_dir_chain4<-MCMCglmm(directionality~scale(sqrt.diff.body.mass)*scale(patristic.distance)+both.sedentary+pairdiet+pairforaging+scale(sympatry.sq)+scale(ln.syntopy)+scale(highest.intraspecific.ses),random=~animal+sp1.sorted+sp2.sorted,
                family="gaussian",ginverse=list(animal=INphylo_FW$Ainv),prior=prior,
                data=pairdata.obs1_subset,nitt=500000,burnin=1000,thin=500)
save(model_subset_dir_chain4,file="model_subset_dir_chain4.RData")

## fits without quad term for DIC comp ##

model_subset_dir_chain1_noquad <-MCMCglmm(directionality~scale(sqrt.diff.body.mass)*scale(patristic.distance)+both.sedentary+pairdiet+pairforaging+scale(sympatry.sq)+scale(ln.syntopy) +scale(highest.intraspecific.ses),random=~animal+sp1.sorted+sp2.sorted,
                           family="gaussian",ginverse=list(animal=INphylo_FW$Ainv),prior=prior,
                           data=pairdata.obs1_subset,nitt=500000,burnin=1000,thin=500)
save(model_subset_dir_chain1_noquad,file="model_subset_dir_chain1_noquad.RData")

model_subset_dir_chain2_noquad <-MCMCglmm(directionality~scale(sqrt.diff.body.mass)*scale(patristic.distance)+both.sedentary+pairdiet+pairforaging+scale(sympatry.sq)+scale(ln.syntopy) +scale(highest.intraspecific.ses),random=~animal+sp1.sorted+sp2.sorted,
                           family="gaussian",ginverse=list(animal=INphylo_FW$Ainv),prior=prior,
                           data=pairdata.obs1_subset,nitt=500000,burnin=1000,thin=500)
save(model_subset_dir_chain2_noquad,file="model_subset_dir_chain2_noquad.RData")

model_subset_dir_chain3_noquad <-MCMCglmm(directionality~scale(sqrt.diff.body.mass)*scale(patristic.distance)+both.sedentary+pairdiet+pairforaging+scale(sympatry.sq)+scale(ln.syntopy) +scale(highest.intraspecific.ses),random=~animal+sp1.sorted+sp2.sorted,
                           family="gaussian",ginverse=list(animal=INphylo_FW$Ainv),prior=prior,
                           data=pairdata.obs1_subset,nitt=500000,burnin=1000,thin=500)
save(model_subset_dir_chain3_noquad,file="model_subset_dir_chain3_noquad.RData")

model_subset_dir_chain4_noquad <-MCMCglmm(directionality~scale(sqrt.diff.body.mass)*scale(patristic.distance)+both.sedentary+pairdiet+pairforaging+scale(sympatry.sq)+scale(ln.syntopy) +scale(highest.intraspecific.ses),random=~animal+sp1.sorted+sp2.sorted,
                           family="gaussian",ginverse=list(animal=INphylo_FW$Ainv),prior=prior,
                           data=pairdata.obs1_subset,nitt=500000,burnin=1000,thin=500)
save(model_subset_dir_chain4_noquad,file="model_subset_dir_chain4_noquad.RData")


###now running fits restricting species pairs that were observed at more than one feeder ('sub.id')

#fits without territoriality

pairdata.obs1.multi<-subset(pairdata,sub.id.cooccurrence.count>1 & observed1==1)

prior<-list(G=list(G1=list(V=1,nu=0.002),G2=list(V=1,nu=0.002),G3=list(V=1,nu=0.002)),R=list(V=1,nu=0.02))


model_dir_multi_chain1<-MCMCglmm(directionality~scale(sqrt.diff.body.mass)*scale(patristic.distance)+both.sedentary+pairdiet+pairforaging+scale(sympatry.sq)+scale(ln.syntopy)+scale(highest.intraspecific.ses),random=~animal+sp1.sorted+sp2.sorted,
                family="gaussian",ginverse=list(animal=INphylo_FW$Ainv),prior=prior,
                data=pairdata.obs1.multi,nitt=500000,burnin=1000,thin=500)
save(model_dir_multi_chain1,file="model_dir_chain1.RData")

model_dir_multi_chain2<-MCMCglmm(directionality~scale(sqrt.diff.body.mass)*scale(patristic.distance)+both.sedentary+pairdiet+pairforaging+scale(sympatry.sq)+scale(ln.syntopy)+scale(highest.intraspecific.ses),random=~animal+sp1.sorted+sp2.sorted,
                family="gaussian",ginverse=list(animal=INphylo_FW$Ainv),prior=prior,
                data=pairdata.obs1.multi,nitt=500000,burnin=1000,thin=500)
save(model_dir_multi_chain2,file="model_dir_multi_chain2.RData")

model_dir_multi_chain3<-MCMCglmm(directionality~scale(sqrt.diff.body.mass)*scale(patristic.distance)+both.sedentary+pairdiet+pairforaging+scale(sympatry.sq)+scale(ln.syntopy)+scale(highest.intraspecific.ses),random=~animal+sp1.sorted+sp2.sorted,
                family="gaussian",ginverse=list(animal=INphylo_FW$Ainv),prior=prior,
                data=pairdata.obs1.multi,nitt=500000,burnin=1000,thin=500)
save(model_dir_multi_chain3,file="model_dir_multi_chain3.RData")

model_dir_multi_chain4<-MCMCglmm(directionality~scale(sqrt.diff.body.mass)*scale(patristic.distance)+both.sedentary+pairdiet+pairforaging+scale(sympatry.sq)+scale(ln.syntopy)+scale(highest.intraspecific.ses),random=~animal+sp1.sorted+sp2.sorted,
                family="gaussian",ginverse=list(animal=INphylo_FW$Ainv),prior=prior,
                data=pairdata.obs1.multi,nitt=500000,burnin=1000,thin=500)
save(model_dir_multi_chain4,file="model_dir_multi_chain4.RData")


#fits without predators

pairdata.dir.nopred <-subset(pairdata,sub.id.cooccurrence.count>1 & observed1==1 & either.predator<1 & !is.na(ses.vec))

prior<-list(G=list(G1=list(V=1,nu=0.002),G2=list(V=1,nu=0.002),G3=list(V=1,nu=0.002)),R=list(V=1,nu=0.02))


model_dir_nopred_chain1<-MCMCglmm(directionality~scale(sqrt.diff.body.mass)*scale(patristic.distance)+both.sedentary+pairdiet+pairforaging+scale(sympatry.sq)+scale(ln.syntopy)+scale(highest.intraspecific.ses),random=~animal+sp1.sorted+sp2.sorted,
                                 family="gaussian",ginverse=list(animal=INphylo_FW$Ainv),prior=prior,
                                 data=pairdata.dir.nopred,nitt=500000,burnin=1000,thin=500)
save(model_dir_nopred_chain1,file="model_dir_nopred_chain1.RData")

model_dir_nopred_chain2<-MCMCglmm(directionality~scale(sqrt.diff.body.mass)*scale(patristic.distance)+both.sedentary+pairdiet+pairforaging+scale(sympatry.sq)+scale(ln.syntopy)+scale(highest.intraspecific.ses),random=~animal+sp1.sorted+sp2.sorted,
                                 family="gaussian",ginverse=list(animal=INphylo_FW$Ainv),prior=prior,
                                 data=pairdata.dir.nopred,nitt=500000,burnin=1000,thin=500)
save(model_dir_nopred_chain2,file="model_dir_nopred_chain2.RData")

model_dir_nopred_chain3<-MCMCglmm(directionality~scale(sqrt.diff.body.mass)*scale(patristic.distance)+both.sedentary+pairdiet+pairforaging+scale(sympatry.sq)+scale(ln.syntopy)+scale(highest.intraspecific.ses),random=~animal+sp1.sorted+sp2.sorted,
                                 family="gaussian",ginverse=list(animal=INphylo_FW$Ainv),prior=prior,
                                 data=pairdata.dir.nopred,nitt=500000,burnin=1000,thin=500)
save(model_dir_nopred_chain3,file="model_dir_nopred_chain3.RData")

model_dir_nopred_chain4<-MCMCglmm(directionality~scale(sqrt.diff.body.mass)*scale(patristic.distance)+both.sedentary+pairdiet+pairforaging+scale(sympatry.sq)+scale(ln.syntopy)+scale(highest.intraspecific.ses),random=~animal+sp1.sorted+sp2.sorted,
                                 family="gaussian",ginverse=list(animal=INphylo_FW$Ainv),prior=prior,
                                 data=pairdata.dir.nopred,nitt=500000,burnin=1000,thin=500)
save(model_dir_nopred_chain4,file="model_dir_nopred_chain4.RData")


